<template>
  <Teleport to="#positioned-effect-location">
    <div style="position: absolute; top: -200px; left: -225px; z-index: 5">
      <div :class="balloonClass">
        <div class="line"></div>
        <div class="ball"></div>
        <div class="bag bg-green-600"><slot /></div>
      </div>
    </div>
  </Teleport>
</template>

<script setup lang="ts">
import { computed } from 'vue';

const props = withDefaults(
  defineProps<{
    appearance: number;
    noAnimation: boolean;
  }>(),
  { appearance: 1, noAnimation: false }
);

const appearanceRange = 5;
defineExpose({
  appearanceRange
});

const balloonNumber = computed(() => (props.appearance ?? Math.floor(Math.random() * appearanceRange)) + 1);
const balloonClass = computed(() => `balloon${balloonNumber.value} ${props.noAnimation ? 'notransition' : ''}`);
</script>

<style scoped lang="scss">
@use 'sass:list';
$purple: #400080, #6000bf, #bf8fef;
$red: #701010, #e75858, #ff8080;
$pink: #bf0060, #e7589f, #ef8fbf;
$green: #008000, #40bf40, #8fef8f;
$orange: #ff8000, #ff9f40, #ffbf80;
$ballColor: ($purple, $red, $green, $pink, $orange);
$lineColor: (#bf8fef, #ff8080, #40bf40, #ef8fbf, #ff9f40);

@mixin size($w, $h: $w, $bdrs: 0) {
  width: $w;
  height: $h;
  border-radius: $bdrs;
}
@mixin abpos($l: initial, $t: initial, $b: initial) {
  position: absolute;
  left: $l;
  top: $t;
  bottom: $b;
}
@mixin textCustom($background, $color: transparent, $width: 1px) {
  background: $background;
  -webkit-background-clip: text;
  -webkit-text-fill-color: transparent;
  -webkit-text-stroke-color: $color;
  -webkit-text-stroke-width: $width;
}
@mixin zAnimation($size) {
  0% {
    font-size: 1em;
  }
  100% {
    font-size: $size;
  }
}
@mixin roundRadius($tl: initial, $br: initial, $tr: initial, $bl: initial) {
  border-top-left-radius: $tl;
  border-bottom-right-radius: $br;
  border-top-right-radius: $tr;
  border-bottom-left-radius: $bl;
}
@mixin ballColor($position: 100%) {
  background-size: 100% 300%;
  background-position: 0 $position;
}

.ball {
  transition: 1.5s;
}
@keyframes changeZ2 {
  @include zAnimation(1.5em);
}
@keyframes changeZ3 {
  @include zAnimation(2em);
}
%ballType {
  overflow: hidden;
  box-shadow: 0px 0px 30px rgba(black, 0.6);
}
%predo {
  content: '';
  display: block;
  transform: rotate(315deg);
}
[class^='balloon'] {
  $size: 6em;
  @include size($size, calc($size * 1.5));
  .ball {
    @include size(100%, calc(100% / 1.5), 150%);
    @include ballColor(50%);
    @include roundRadius(425%, 425%, 220%, 425%); //tl,br,tr,bl
    @extend %ballType;
    transform: rotate(135deg);
    &:after {
      @include ballColor(70%);
      @include size($size * 1.5, calc($size / 5), 50%);
      @include abpos(-20%, initial, 45%);
      @extend %predo;
    }
    &:before {
      @include ballColor(65%);
      @include size(calc($size * 1.5), calc($size / 1.5), 50%);
      @include abpos(-23%, initial, 20%);
      @extend %predo;
    }
  }
  .line {
    @include size(15%, 9%);
    @include abpos(43%, initial, calc($size / 3.7));
    transform: rotate(136deg);
  }
  .bag {
    @include size(40%, 17%, 5px);
    @include abpos(30.5%, initial, 0);
    box-shadow: inset -4px -5px rgba(black, 0.1);
    display: flex;
    justify-content: center;
    align-items: center;
  }
}
@for $i from 1 through 5 {
  .balloon#{$i} {
    $animation-duration: 2s;
    $animation-timing-function: ease-in-out;
    $animation-delay: 0s;
    $animation-iteration-count: 1;
    $animation-direction: alternate;

    transform: rotate($i * 10 - 25 + deg);
    animation: upDown $animation-duration $animation-timing-function $animation-delay $animation-iteration-count $animation-direction;
    &:hover {
      animation-play-state: paused;
    }
    animation-fill-mode: forwards;
    .ball,
    .ball:after,
    .ball:before {
      background: linear-gradient(list.nth($ballColor, $i));
    }
    .line {
      border: 2px ridge list.nth($lineColor, $i);
    }
  }
}
@keyframes upDown {
  0% {
    transform: translate(100px, 150px);
    scale: 0;
  }
  100% {
    transform: translate(0, 0);
    scale: 1;
  }
}

.notransition {
  animation: none !important;
}
</style>
